/*
   Support - Provides some big and little endian abstraction functions.
   Copyright (C) 1998, 1999  Caolan McNamara

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */
/*
   Caolan McNamara <Caolan.McNamara@ul.ie>
   Real Life: Caolan McNamara           *  Doing: MSc in HCI
   Work: Caolan.McNamara@ul.ie          *  Phone: +353-61-202699
   URL: http://www.csn.ul.ie/~caolan    *  Sig: an oblique strategy
 */


#include <support.h>


U8
fil_sreadU8 (U8 * in)
{
  return *in;
}


U16
fil_sreadU16 (U8 * in)
{
  U8 temp1, temp2;
  U16 ret;

  temp1 = *(in);
  temp2 = *(in + 1);
  ret = temp2;
  ret = ret << 8;
  ret += temp1;
  return ret;
}


U32
fil_sreadU32 (U8 * in)
{
  U16 temp1, temp2;
  U32 ret;

  temp1 = fil_sreadU16 (in);
  temp2 = fil_sreadU16 (in + 2);
  ret = temp2;
  ret = ret << 16;
  ret += temp1;
  return ret;
}

void
fil_swriteU8 (U8 * dest, U8 * src)
{
  *(dest) = *(src);
}

void
fil_swriteU16 (U8 * dest, U16 * src)
{
  *(dest) = *((U8*)src);
  *(dest+1) = *(((U8*)src)+1);
}

void
fil_swriteU32 (U8 * dest, U32 * src)
{
	fil_swriteU16 (dest, (U16*)src);
	fil_swriteU16 (dest+2, ( U16* )( ((U8*)src)+2 )  );
}
